Rounding error in OFStandard::atof
Status: Closed Start date: 2024-01-12
Priority: Normal Due date:

Assignee: Marco Eichelberg % Done: 100%
Category: Estimated time: 3:00 hours

Target version:
Module: Compiler:

Operating System:

Description

The following code shows that OF Standard::atof() can produce rounding errors that prevent a lossless round-trip e.g. from DICOM
FD to JSON and back.
This sample program shows that OFStandard::atof() produces results that are different from those of std::stod():

#include "dcmtk/dcmdata/dcfilefo.h"

int main () {
std::string result;
result = "14.399999999999999";

OFBool success;

double d2 = OFStandard::atof (result.c_str(), &success);
std::cout << std::hexfloat << d2 << std::endl;

double d3 = std::stod(result);

std::cout << std::hexfloat << d3 << std::endl;

return 0;

}

Reported 2024-01-11 by Mathieu Malaterre <mathieu.malaterre@gmail.com>

History

#1 - 2024-01-12 18:05 - Marco Eichelberg
- Status changed from New to Closed

- % Done changed from 0 to 100

- Estimated time set to 3:00 h

Closed by commit #ecbf61cb7.
